#region using
using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;
using System.Text.RegularExpressions;
using System.Reflection;
#endregion

namespace Cotyounoyume{
	public class Orgasm
	{
		#region common parameters
		public Atom atom;
		public EBATCore core;

		public bool disableLog = true;
		public bool isDuringOrgasm = false;
		public bool isDuringAfterglow = false;
		public int orgasmCount = 0;
		public float orgasmOpeningTime;
		public int orgasmState;
		public int orgasmWaveCycleBig;
		public int orgasmWaveCycleSmall;
		public int orgasmWaveCycleBigMax = 10;
		public int orgasmWaveCycleSmallMax = 4;
		public int orgasmWaveCycleBigMin = 3;
		public int orgasmWaveCycleSmallMin = 1;

		public int orgasmAfterglowCycleBig;
		public int orgasmAfterglowCycleSmall;
		public int orgasmAfterglowCount;
		public float orgasmAfterglowIntervalPlus = 0.3f;
		public int orgasmAfterglowCycleBigMax = 3;
		public int orgasmAfterglowCycleSmallMax = 1;
		public int orgasmAfterglowCycleBigMin = 2;
		public int orgasmAfterglowCycleSmallMin = 1;
		public bool isFirstWave = false;
		public float orgasmStartInterval = 0f;
		public float orgasmTimeOffset1 = 0.05f;
		public float orgasmTimeOffset2 = 0.05f;
		public float orgasmTimeRandomOffset1;
		public float orgasmTimeRandomOffset2;
		public float orgasmWaveCycleInterval;
		public float orgasmStrength;
		public float orgasmWaveCycleIntervalBigMax = 0.4f;
		public float orgasmWaveCycleIntervalSmallMax = 0.1f;
		public float orgasmAfterglowCycleIntervalBigMax = 0.8f;
		public  float orgasmAfterglowCycleIntervalSmallMax = 0.2f;
		public float orgasmStrengthMax = 0f;
		public float afterglowStrengthMax = 0f;
		public float orgasmCooldownTime;
		public float orgasmCooldownTimeOffset = 6.0f;
		#endregion
		
		public Orgasm(EBATCore core){
			atom = core.atom;
			this.core = core;
		}
		
		public void loadSettings(){
			try{
				#region general core.settings from json
				disableLog = core.disableLog;
				orgasmStrengthMax      = core.settings["Orgasm"]["OrgasmStrength"].AsFloat;
				afterglowStrengthMax   = core.settings["Orgasm"]["AfterglowStrength"].AsFloat;
				core.belly.bendBackwardThreshold   = core.settings["Orgasm"]["BendingBackwardRatio"].AsFloat;
				
				orgasmWaveCycleBigMax   = core.settings["Orgasm"]["WaveBigCycleMax"].AsInt;
				orgasmWaveCycleBigMin   = core.settings["Orgasm"]["WaveBigCycleMin"].AsInt;
				orgasmWaveCycleSmallMax = core.settings["Orgasm"]["WaveSmallCycleMax"].AsInt;
				orgasmWaveCycleSmallMin = core.settings["Orgasm"]["WaveSmallCycleMin"].AsInt;
				orgasmAfterglowCycleBigMax   = core.settings["Orgasm"]["AfterglowBigCycleMax"].AsInt;
				orgasmAfterglowCycleBigMin   = core.settings["Orgasm"]["AfterglowBigCycleMin"].AsInt;
				orgasmAfterglowCycleSmallMax = core.settings["Orgasm"]["AfterglowSmallCycleMax"].AsInt;
				orgasmAfterglowCycleSmallMin = core.settings["Orgasm"]["AfterglowSmallCycleMin"].AsInt;
				orgasmWaveCycleIntervalBigMax        = core.settings["Orgasm"]["WaveBigCycleIntervalMax"].AsFloat;
				orgasmWaveCycleIntervalSmallMax      = core.settings["Orgasm"]["WaveSmallCycleIntervalMax"].AsFloat;
				orgasmAfterglowCycleIntervalBigMax   = core.settings["Orgasm"]["AfterglowBigCycleIntervalMax"].AsFloat;
				orgasmAfterglowCycleIntervalSmallMax = core.settings["Orgasm"]["AfterglowSmallCycleIntervalMax"].AsFloat;
				#endregion
				
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void applySettings(){
			try{

			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void maintenance(){
			try{

			}catch (Exception e){
				core.loggerE(e);
			}
		}

		public void orgasmCheck(float currentTime){
			try{
				if(core.gauge >= core.stageThreshold[5]){
					if(isDuringOrgasm == false || (isDuringOrgasm == true && isDuringAfterglow == true)){
						if(currentTime > orgasmCooldownTime){
							orgasmStart();
						}
					}
				}
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void update(float currentTime){
			try{
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void orgasmStart(){
			try{
				core.logger("orgasmStart");
				core.sound.playSound("climax", Time.time);
				orgasmOpeningTime = Time.time;
				orgasmCooldownTime = 0f;
				isDuringOrgasm = true;
				isDuringAfterglow = false;
				orgasmState = 0;
				orgasmWaveCycleBig = UnityEngine.Random.Range(orgasmWaveCycleBigMin, orgasmWaveCycleBigMax);
				core.belly.changePositionAndRotationState();
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void orgasmFinish(){
			try{
				core.logger("orgasmFinish");
				orgasmCooldownTime = 0f;
				orgasmOpeningTime = Time.time;
				orgasmCount++;
				isDuringOrgasm = false;
				isDuringAfterglow = false;
				core.isBreathActive = false;
				core.belly.restorePositionAndRotation();
				orgasmState = 0;
				core.gauge = 0;
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void calcGauge(){
			try{
				float recoveryRatio;
				int tmpOrgasmCount = (orgasmCount > 10) ? 10 : orgasmCount;
				if(orgasmCount < 5){
					recoveryRatio = (float)orgasmCount * 0.2f;
					core.gauge = core.stageThreshold[3] + (int)((float)(core.stageThreshold[4] - core.stageThreshold[3]) * recoveryRatio);
				}else{
					recoveryRatio = (float)orgasmCount * (orgasmCount - 5) * 0.15f;
					core.gauge = core.stageThreshold[4] + (int)((float)(core.stageThreshold[5] - core.stageThreshold[4]) * recoveryRatio);
				}
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void orgasmControl(float time){
			try{
				if(! isDuringOrgasm){
					return;
				}
				float delta = time - orgasmOpeningTime;
				if(orgasmState == -1){
					orgasmOpeningTime = Time.time;
				}else if(orgasmState == 0){
					if(delta < orgasmStartInterval){
						//nop
					}else{
						orgasmState = 1;
						orgasmOpeningTime = Time.time;
						isFirstWave = true;
					}
				}else if(orgasmState == 1){
					if(isFirstWave){
						orgasmWaveCycleSmall = UnityEngine.Random.Range(orgasmWaveCycleSmallMin, orgasmWaveCycleSmallMax);
						core.belly.bendHerselfBack(Time.time);
						core.sound.playSound("moan", Time.time);
					}
					orgasmTimeRandomOffset1 = orgasmTimeOffset1 * UnityEngine.Random.Range(0.0f, 0.3f);
					orgasmTimeRandomOffset2 = orgasmTimeOffset2 * UnityEngine.Random.Range(0.0f, 0.3f);
					core.updateAll();
					orgasmState = 2;
				}else if(orgasmState == 2){
					if(delta < orgasmTimeOffset1 + orgasmTimeRandomOffset1){
						orgasmStrength = isFirstWave ? UnityEngine.Random.Range(orgasmStrengthMax * 1.2f, orgasmStrengthMax * 1.5f) : UnityEngine.Random.Range(orgasmStrengthMax * 0.5f, orgasmStrengthMax);
						core.belly.bellyBump(orgasmStrength, time);
					}else if(delta < orgasmTimeOffset1 + orgasmTimeRandomOffset1 + orgasmTimeOffset2 + orgasmTimeRandomOffset2){
						orgasmStrength = isFirstWave ? UnityEngine.Random.Range(orgasmStrengthMax * 1.2f, orgasmStrengthMax * 1.5f) : UnityEngine.Random.Range(orgasmStrengthMax * 0.5f, orgasmStrengthMax);
						core.belly.bellyDents(orgasmStrength, time);
					}else{
						if(orgasmWaveCycleSmall > 0){
							orgasmState = 3;
							orgasmOpeningTime = time;
							orgasmWaveCycleInterval = orgasmWaveCycleIntervalSmallMax * UnityEngine.Random.Range(0.5f, 1.5f);
							core.logger("orgasmControl: big/small/waveState = " + orgasmWaveCycleBig + "/" + orgasmWaveCycleSmall + "/" + orgasmState);						
						}else if(orgasmWaveCycleSmall == 0 && orgasmWaveCycleBig > 0){
							orgasmState = 3;
							orgasmOpeningTime = time;
							orgasmWaveCycleInterval = orgasmWaveCycleIntervalBigMax * UnityEngine.Random.Range(0.8f, 3.0f);
							core.logger("orgasmControl: big/small/waveState = " + orgasmWaveCycleBig + "/" + orgasmWaveCycleSmall + "/" + orgasmState);												
						}else{
							core.logger("*** afterglow start.");
							calcGauge();
							orgasmState = 4;
							orgasmAfterglowCount = 0;
							isDuringAfterglow = true;
							isFirstWave = true;
							orgasmAfterglowCycleBig = UnityEngine.Random.Range(orgasmAfterglowCycleBigMin, orgasmAfterglowCycleBigMax);
							orgasmOpeningTime = time;
							orgasmCooldownTime = time + orgasmCooldownTimeOffset;
						}
					}
				}else if(orgasmState == 3){
					if(delta < orgasmWaveCycleInterval){
						//nop
					}else{
						if(orgasmWaveCycleSmall > 0){
							isFirstWave = false;
							orgasmWaveCycleSmall--;
							orgasmOpeningTime = time;
							orgasmState = 1;
							core.logger("orgasmControl: big/small/waveState = " + orgasmWaveCycleBig + "/" + orgasmWaveCycleSmall + "/" + orgasmState);												
						}else if(orgasmWaveCycleSmall == 0){
							isFirstWave = true;
							orgasmWaveCycleBig--;
							orgasmOpeningTime = time;
							orgasmState = 1;
							core.logger("orgasmControl: big/small/waveState = " + orgasmWaveCycleBig + "/" + orgasmWaveCycleSmall + "/" + orgasmState);												
						}
					}

				}else if(orgasmState == 4){
					orgasmAfterglowCount++;
					if(isFirstWave){
						orgasmAfterglowCycleSmall = UnityEngine.Random.Range(orgasmAfterglowCycleSmallMin, orgasmAfterglowCycleSmallMax);
					}
					orgasmTimeRandomOffset1 = orgasmTimeOffset1 * UnityEngine.Random.Range(0.0f, 0.3f);
					orgasmTimeRandomOffset2 = orgasmTimeOffset2 * UnityEngine.Random.Range(0.0f, 0.3f);
					core.updateAll();
					orgasmState = 5;
				}else if(orgasmState == 5){
					if(delta < orgasmTimeOffset1 + orgasmTimeRandomOffset1){
//						orgasmStrength = isFirstWave ? UnityEngine.Random.Range(1.0f, 1.5f) : UnityEngine.Random.Range(0.3f, 0.8f);
						orgasmStrength = UnityEngine.Random.Range(afterglowStrengthMax * 0.5f, afterglowStrengthMax);
						core.belly.bellyBump(orgasmStrength, time);
					}else if(delta < orgasmTimeOffset1 + orgasmTimeRandomOffset1 + orgasmTimeOffset2 + orgasmTimeRandomOffset2){
//						orgasmStrength = isFirstWave ? UnityEngine.Random.Range(1.0f, 1.5f) : UnityEngine.Random.Range(0.3f, 0.8f);
						orgasmStrength = UnityEngine.Random.Range(afterglowStrengthMax * 0.5f, afterglowStrengthMax);
						core.belly.bellyDents(orgasmStrength, time);
					}else{
						if(orgasmAfterglowCycleSmall > 0){
							orgasmState = 6;
							orgasmOpeningTime = time;
							orgasmWaveCycleInterval = orgasmAfterglowCycleIntervalSmallMax * UnityEngine.Random.Range(0.5f, 1.5f);
							core.logger("orgasmControl: big/small/waveState = " + orgasmWaveCycleBig + "/" + orgasmWaveCycleSmall + "/" + orgasmState);						
							core.logger("orgasmControl: afterglow big/small/waveState = " + orgasmAfterglowCycleBig + "/" + orgasmAfterglowCycleSmall + "/" + orgasmState);						
						}else if(orgasmAfterglowCycleSmall == 0 && orgasmAfterglowCycleBig > 0){
							orgasmState = 6;
							orgasmOpeningTime = time;
							orgasmWaveCycleInterval = orgasmAfterglowCycleIntervalBigMax * UnityEngine.Random.Range(0.8f, 3.0f);
							orgasmWaveCycleInterval += orgasmAfterglowCount * orgasmAfterglowIntervalPlus;
							core.logger("orgasmControl: big/small/waveState = " + orgasmWaveCycleBig + "/" + orgasmWaveCycleSmall + "/" + orgasmState);												
							core.logger("orgasmControl: afterglow big/small/waveState = " + orgasmAfterglowCycleBig + "/" + orgasmAfterglowCycleSmall + "/" + orgasmState);						
						}else{
							orgasmFinish();
						}
					}
				}else if(orgasmState == 6){
					if(delta < orgasmWaveCycleInterval){
						//nop
					}else{
						if(orgasmAfterglowCycleSmall > 0){
							isFirstWave = false;
							orgasmAfterglowCycleSmall--;
							orgasmOpeningTime = time;
							orgasmState = 4;
							core.logger("orgasmControl: big/small/waveState = " + orgasmWaveCycleBig + "/" + orgasmWaveCycleSmall + "/" + orgasmState);												
							core.logger("orgasmControl: afterglow big/small/waveState = " + orgasmAfterglowCycleBig + "/" + orgasmAfterglowCycleSmall + "/" + orgasmState);						
						}else if(orgasmAfterglowCycleSmall == 0){
							isFirstWave = true;
							orgasmAfterglowCycleBig--;
							orgasmOpeningTime = time;
							orgasmState = 4;
							core.logger("orgasmControl: big/small/waveState = " + orgasmWaveCycleBig + "/" + orgasmWaveCycleSmall + "/" + orgasmState);												
							core.logger("orgasmControl: afterglow big/small/waveState = " + orgasmAfterglowCycleBig + "/" + orgasmAfterglowCycleSmall + "/" + orgasmState);						
						}
					}
				}
			}catch (Exception e){
				core.loggerE(e);
			}
		}
	}
}
